XDP hardware hints discussion mail archive
 help / color / mirror / Atom feed
From: Alexander Lobakin <alexandr.lobakin@intel.com>
To: Alexei Starovoitov <ast@kernel.org>,
	Daniel Borkmann <daniel@iogearbox.net>,
	Andrii Nakryiko <andrii@kernel.org>
Cc: "Alexander Lobakin" <alexandr.lobakin@intel.com>,
	"Larysa Zaremba" <larysa.zaremba@intel.com>,
	"Michal Swiatkowski" <michal.swiatkowski@linux.intel.com>,
	"Jesper Dangaard Brouer" <hawk@kernel.org>,
	"Björn Töpel" <bjorn@kernel.org>,
	"Magnus Karlsson" <magnus.karlsson@intel.com>,
	"Maciej Fijalkowski" <maciej.fijalkowski@intel.com>,
	"Jonathan Lemon" <jonathan.lemon@gmail.com>,
	"Toke Hoiland-Jorgensen" <toke@redhat.com>,
	"Lorenzo Bianconi" <lorenzo@kernel.org>,
	"David S. Miller" <davem@davemloft.net>,
	"Eric Dumazet" <edumazet@google.com>,
	"Jakub Kicinski" <kuba@kernel.org>,
	"Paolo Abeni" <pabeni@redhat.com>,
	"Jesse Brandeburg" <jesse.brandeburg@intel.com>,
	"John Fastabend" <john.fastabend@gmail.com>,
	"Yajun Deng" <yajun.deng@linux.dev>,
	"Willem de Bruijn" <willemb@google.com>,
	bpf@vger.kernel.org, netdev@vger.kernel.org,
	linux-kernel@vger.kernel.org, xdp-hints@xdp-project.net
Subject: [xdp-hints] [PATCH RFC bpf-next 52/52] selftests/bpf: add XDP Generic Hints selftest
Date: Tue, 28 Jun 2022 21:48:12 +0200	[thread overview]
Message-ID: <20220628194812.1453059-53-alexandr.lobakin@intel.com> (raw)
In-Reply-To: <20220628194812.1453059-1-alexandr.lobakin@intel.com>

Add a new BPF selftest which checks whether XDP Generic metadata
works correctly using generic/skb XDP path. It is always available
on any interface, so must always succeed.
It uses special BPF program which works as follows:

* tries to access metadata memory via bpf_access_mem_end();
* checks the frame size. For sizes < 128 bytes, drop packets with
  metadata present, so that we could check that setting the
  threshold works;
* for sizes 128+, drop packets with no meta. Otherwise, check that
  it has correct magic and BTF ID matches with the one written by
  the verifier;
* finally, pass packets with fully correct generic meta up the
  stack.

And the test itself does the following:

1) attaches that XDP prog to veth interfaces with the threshold of
   1, i.e. enable metadata generation for every packet;
2) ensures that the prog drops frames lesser than 128 bytes as
   intended (see above);
3) raises the threshold to 128 bytes (test updating the parameters
   without replacing the prog);
4) ensures that now no drops occur and that meta for frames >= 128
   is valid.

As it involves multiple userspace prog invocation, it performs BPF
link pinning to make it freerunning. `ip netns exec` creates a new
mount namespace (including sysfs) on each execution, the script
now does a temporary persistent BPF FS mountpoint in the tests
directory, so that pinned progs/links will be accessible across
the launches.

Co-developed-by: Larysa Zaremba <larysa.zaremba@intel.com>
Signed-off-by: Larysa Zaremba <larysa.zaremba@intel.com>
Signed-off-by: Alexander Lobakin <alexandr.lobakin@intel.com>
---
 tools/testing/selftests/bpf/.gitignore        |   1 +
 tools/testing/selftests/bpf/Makefile          |   4 +-
 .../selftests/bpf/progs/test_xdp_meta.c       |  36 +++
 tools/testing/selftests/bpf/test_xdp_meta.c   | 294 ++++++++++++++++++
 tools/testing/selftests/bpf/test_xdp_meta.sh  |  51 +++
 5 files changed, 385 insertions(+), 1 deletion(-)
 create mode 100644 tools/testing/selftests/bpf/test_xdp_meta.c

diff --git a/tools/testing/selftests/bpf/.gitignore b/tools/testing/selftests/bpf/.gitignore
index ca2f47f45670..7d4de9d9002c 100644
--- a/tools/testing/selftests/bpf/.gitignore
+++ b/tools/testing/selftests/bpf/.gitignore
@@ -44,3 +44,4 @@ test_cpp
 xdpxceiver
 xdp_redirect_multi
 xdp_synproxy
+/test_xdp_meta
diff --git a/tools/testing/selftests/bpf/Makefile b/tools/testing/selftests/bpf/Makefile
index 4fbd88a8ed9e..aca8867deb8c 100644
--- a/tools/testing/selftests/bpf/Makefile
+++ b/tools/testing/selftests/bpf/Makefile
@@ -82,7 +82,7 @@ TEST_PROGS_EXTENDED := with_addr.sh \
 TEST_GEN_PROGS_EXTENDED = test_sock_addr test_skb_cgroup_id_user \
 	flow_dissector_load test_flow_dissector test_tcp_check_syncookie_user \
 	test_lirc_mode2_user xdping test_cpp runqslower bench bpf_testmod.ko \
-	xdpxceiver xdp_redirect_multi xdp_synproxy
+	xdpxceiver xdp_redirect_multi xdp_synproxy test_xdp_meta
 
 TEST_CUSTOM_PROGS = $(OUTPUT)/urandom_read
 
@@ -589,6 +589,8 @@ $(OUTPUT)/bench: $(OUTPUT)/bench.o \
 	$(call msg,BINARY,,$@)
 	$(Q)$(CC) $(CFLAGS) $(LDFLAGS) $(filter %.a %.o,$^) $(LDLIBS) -o $@
 
+$(OUTPUT)/test_xdp_meta: | $(OUTPUT)/test_xdp_meta.skel.h
+
 EXTRA_CLEAN := $(TEST_CUSTOM_PROGS) $(SCRATCH_DIR) $(HOST_SCRATCH_DIR)	\
 	prog_tests/tests.h map_tests/tests.h verifier/tests.h		\
 	feature bpftool							\
diff --git a/tools/testing/selftests/bpf/progs/test_xdp_meta.c b/tools/testing/selftests/bpf/progs/test_xdp_meta.c
index fe2d71ae0e71..0b05d1c3979b 100644
--- a/tools/testing/selftests/bpf/progs/test_xdp_meta.c
+++ b/tools/testing/selftests/bpf/progs/test_xdp_meta.c
@@ -2,6 +2,8 @@
 #include <linux/if_ether.h>
 #include <linux/pkt_cls.h>
 
+#include <bpf/bpf_core_read.h>
+#include <bpf/bpf_endian.h>
 #include <bpf/bpf_helpers.h>
 
 #define __round_mask(x, y) ((__typeof__(x))((y) - 1))
@@ -50,4 +52,38 @@ int ing_xdp(struct xdp_md *ctx)
 	return XDP_PASS;
 }
 
+#define TEST_META_THRESH	128
+
+SEC("xdp")
+int ing_hints(struct xdp_md *ctx)
+{
+	const struct xdp_meta_generic *md;
+	__le64 genid;
+
+	md = bpf_access_mem_end(ctx->data_meta, ctx->data, sizeof(*md),
+				sizeof(*md));
+
+	/* Selftest enables metadata starting from 128 byte frame size, fail it
+	 * if we receive a shorter frame with metadata
+	 */
+	if (ctx->data_end - ctx->data < TEST_META_THRESH)
+		return md ? XDP_DROP : XDP_PASS;
+
+	if (!md)
+		return XDP_DROP;
+
+	if (md->magic_id != bpf_cpu_to_le16(XDP_META_GENERIC_MAGIC))
+		return XDP_DROP;
+
+	genid = bpf_cpu_to_le64(bpf_core_type_id_kernel(typeof(*md)));
+	if (md->full_id != genid)
+		return XDP_DROP;
+
+	/* Tx flags must be zeroed */
+	if (md->tx_flags)
+		return XDP_DROP;
+
+	return XDP_PASS;
+}
+
 char _license[] SEC("license") = "GPL";
diff --git a/tools/testing/selftests/bpf/test_xdp_meta.c b/tools/testing/selftests/bpf/test_xdp_meta.c
new file mode 100644
index 000000000000..e5c147d19190
--- /dev/null
+++ b/tools/testing/selftests/bpf/test_xdp_meta.c
@@ -0,0 +1,294 @@
+// SPDX-License-Identifier: GPL-2.0
+/* Copyright (C) 2022, Intel Corporation. */
+
+#define _GNU_SOURCE	/* asprintf() */
+
+#include <bpf/bpf.h>
+#include <getopt.h>
+#include <net/if.h>
+#include <uapi/linux/if_link.h>
+
+#include "test_xdp_meta.skel.h"
+
+struct test_meta_op_opts {
+	struct test_xdp_meta	*skel;
+	const char		*cmd;
+	char			*path;
+	__u32			ifindex;
+	__u32			flags;
+	__u64			btf_id;
+	__u32			meta_thresh;
+};
+
+struct test_meta_opt_desc {
+	const char		*arg;
+	const char		*help;
+};
+
+#define OPT(n, a, s) {				\
+	.name			= #n,		\
+	.has_arg		= (a),		\
+	.val			= #s[0],	\
+}
+
+#define DESC(a, h) {				\
+	.arg			= (a),		\
+	.help			= (h),		\
+}
+
+static const struct option test_meta_opts[] = {
+	OPT(dev,		required_argument,	d),
+	OPT(fs,			required_argument,	f),
+	OPT(help,		no_argument,		h),
+	OPT(meta-thresh,	optional_argument,	M),
+	OPT(mode,		required_argument,	m),
+	{ /* Sentinel */ },
+};
+
+static const struct test_meta_opt_desc test_meta_descs[] = {
+	DESC("= < IFNAME | IFINDEX >", "target interface name or index"),
+	DESC("= < MOUNTPOINT >", "BPF FS mountpoint"),
+	DESC(NULL, "display this text and exit"),
+	DESC("= [ THRESH ]", "enable Generic metadata generation (frame size)"),
+	DESC("= < skb | drv | hw >", "force particular XDP mode"),
+};
+
+static void test_meta_usage(char *argv[], bool err)
+{
+	FILE *out = err ? stderr : stdout;
+	__u32 i = 0;
+
+	fprintf(out,
+		"Usage:\n\t%s COMMAND < -d | --dev= >  < IFNAME | IFINDEX > [ OPTIONS ]\n\n",
+		argv[0]);
+	fprintf(out, "OPTIONS:\n");
+
+	for (const struct option *opt = test_meta_opts; opt->name; opt++) {
+		fprintf(out, "\t-%c, --%s", opt->val, opt->name);
+		fprintf(out, "%s\t", test_meta_descs[i].arg ? : "\t\t");
+		fprintf(out, "%s\n", test_meta_descs[i++].help);
+	}
+}
+
+static int test_meta_link_attach(const struct test_meta_op_opts *opts)
+{
+	LIBBPF_OPTS(bpf_xdp_attach_opts, la_opts,
+		    .flags		= opts->flags,
+		    .btf_id		= opts->btf_id,
+		    .meta_thresh	= opts->meta_thresh);
+	struct bpf_link *link;
+	int ret;
+
+	link = bpf_program__attach_xdp_opts(opts->skel->progs.ing_hints,
+					    opts->ifindex, &la_opts);
+	ret = libbpf_get_error(link);
+	if (ret) {
+		fprintf(stderr, "Failed to attach XDP program: %s (%d)\n",
+			strerror(-ret), ret);
+		return ret;
+	}
+
+	opts->skel->links.ing_hints = link;
+
+	ret = bpf_link__pin(link, opts->path);
+	if (ret)
+		fprintf(stderr, "Failed to pin XDP link at %s: %s (%d)\n",
+			opts->path, strerror(-ret), ret);
+
+	bpf_link__disconnect(link);
+
+	return ret;
+}
+
+static int test_meta_link_update(const struct test_meta_op_opts *opts)
+{
+	LIBBPF_OPTS(bpf_link_update_opts, lu_opts,
+		    .xdp.new_btf_id		= opts->btf_id,
+		    .xdp.new_meta_thresh	= opts->meta_thresh);
+	struct bpf_link *link;
+	int ret;
+
+	link = bpf_link__open(opts->path);
+	ret = libbpf_get_error(link);
+	if (ret) {
+		fprintf(stderr, "Failed to open XDP link at %s: %s (%d)\n",
+			opts->path, strerror(-ret), ret);
+		return ret;
+	}
+
+	opts->skel->links.ing_hints = link;
+
+	ret = bpf_link_update(bpf_link__fd(link),
+			      bpf_program__fd(opts->skel->progs.ing_hints),
+			      &lu_opts);
+	if (ret)
+		fprintf(stderr, "Failed to update XDP link: %s (%d)\n",
+			strerror(-ret), ret);
+
+	return ret;
+}
+
+static int test_meta_link_detach(const struct test_meta_op_opts *opts)
+{
+	struct bpf_link *link;
+	int ret;
+
+	link = bpf_link__open(opts->path);
+	ret = libbpf_get_error(link);
+	if (ret) {
+		fprintf(stderr, "Failed to open XDP link at %s: %s (%d)\n",
+			opts->path, strerror(-ret), ret);
+		return ret;
+	}
+
+	opts->skel->links.ing_hints = link;
+
+	ret = bpf_link__unpin(link);
+	if (ret) {
+		fprintf(stderr, "Failed to unpin XDP link: %s (%d)\n",
+			strerror(-ret), ret);
+		return ret;
+	}
+
+	ret = bpf_link__detach(link);
+	if (ret)
+		fprintf(stderr, "Failed to detach XDP link: %s (%d)\n",
+			strerror(-ret), ret);
+
+	return ret;
+}
+
+static int test_meta_parse_args(struct test_meta_op_opts *opts, int argc,
+				char *argv[])
+{
+	int opt, longidx, ret;
+
+	while (1) {
+		opt = getopt_long(argc, argv, "d:f:hM::m:", test_meta_opts,
+				  &longidx);
+		if (opt < 0)
+			break;
+
+		switch (opt) {
+		case 'd':
+			opts->ifindex = if_nametoindex(optarg);
+			if (!opts->ifindex)
+				opts->ifindex = strtoul(optarg, NULL, 0);
+
+			break;
+		case 'f':
+			opts->path = optarg;
+			break;
+		case 'h':
+			test_meta_usage(argv, false);
+			return 0;
+		case 'M':
+			ret = libbpf_get_type_btf_id("struct xdp_meta_generic",
+						     &opts->btf_id);
+			if (ret) {
+				fprintf(stderr,
+					"Failed to get BTF ID: %s (%d)\n",
+					strerror(-ret), ret);
+				return ret;
+			}
+
+			/* Allow both `-M64` and `-M 64` */
+			if (!optarg && optind < argc && argv[optind] &&
+			    *argv[optind] >= '0' && *argv[optind] <= '9')
+				optarg = argv[optind];
+
+			opts->meta_thresh = strtoul(optarg ? : "1", NULL, 0);
+			break;
+		case 'm':
+			if (!strcmp(optarg, "skb"))
+				opts->flags = XDP_FLAGS_SKB_MODE;
+			else if (!strcmp(optarg, "drv"))
+				opts->flags = XDP_FLAGS_DRV_MODE;
+			else if (!strcmp(optarg, "hw"))
+				opts->flags = XDP_FLAGS_HW_MODE;
+
+			if (opts->flags)
+				break;
+
+			/* fallthrough */
+		default:
+			test_meta_usage(argv, true);
+			return -EINVAL;
+		}
+	}
+
+	if (optind >= argc || !argv[optind]) {
+		fprintf(stderr, "Command is required\n");
+		test_meta_usage(argv, true);
+
+		return -EINVAL;
+	}
+
+	opts->cmd = argv[optind];
+
+	return 0;
+}
+
+int main(int argc, char *argv[])
+{
+	struct test_meta_op_opts opts = { };
+	int ret;
+
+	libbpf_set_strict_mode(LIBBPF_STRICT_ALL);
+
+	if (argc < 3) {
+		test_meta_usage(argv, true);
+		return -EINVAL;
+	}
+
+	ret = test_meta_parse_args(&opts, argc, argv);
+	if (ret)
+		return ret;
+
+	if (!opts.ifindex) {
+		fprintf(stderr, "Invalid or missing device argument\n");
+		test_meta_usage(argv, true);
+
+		return -EINVAL;
+	}
+
+	opts.skel = test_xdp_meta__open_and_load();
+	ret = libbpf_get_error(opts.skel);
+	if (ret) {
+		fprintf(stderr, "Failed to load test_xdp_meta skeleton: %s (%d)\n",
+			strerror(-ret), ret);
+		return ret;
+	}
+
+	ret = asprintf(&opts.path, "%s/xdp/%s-%u", opts.path ? : "/sys/fs/bpf",
+		       opts.skel->skeleton->name, opts.ifindex);
+	ret = ret < 0 ? -errno : 0;
+	if (ret) {
+		fprintf(stderr, "Failed to allocate path string: %s (%d)\n",
+			strerror(-ret), ret);
+		goto meta_destroy;
+	}
+
+	if (!strcmp(opts.cmd, "attach")) {
+		ret = test_meta_link_attach(&opts);
+	} else if (!strcmp(opts.cmd, "update")) {
+		ret = test_meta_link_update(&opts);
+	} else if (!strcmp(opts.cmd, "detach")) {
+		ret = test_meta_link_detach(&opts);
+	} else {
+		fprintf(stderr, "Invalid command '%s'\n", opts.cmd);
+		test_meta_usage(argv, true);
+
+		ret = -EINVAL;
+	}
+
+	if (ret)
+		fprintf(stderr, "Failed to execute command '%s': %s (%d)\n",
+			opts.cmd, strerror(-ret), ret);
+
+	free(opts.path);
+meta_destroy:
+	test_xdp_meta__destroy(opts.skel);
+
+	return ret;
+}
diff --git a/tools/testing/selftests/bpf/test_xdp_meta.sh b/tools/testing/selftests/bpf/test_xdp_meta.sh
index 7232714e89b3..79c2ccb68dda 100755
--- a/tools/testing/selftests/bpf/test_xdp_meta.sh
+++ b/tools/testing/selftests/bpf/test_xdp_meta.sh
@@ -5,6 +5,11 @@ readonly KSFT_SKIP=4
 readonly NS1="ns1-$(mktemp -u XXXXXX)"
 readonly NS2="ns2-$(mktemp -u XXXXXX)"
 
+# We need a persistent BPF FS mointpoint. `ip netns exec` prepares a different
+# temporary one on each invocation
+readonly FS="$(mktemp -d XXXXXX)"
+mount -t bpf bpffs ${FS}
+
 cleanup()
 {
 	if [ "$?" = "0" ]; then
@@ -14,9 +19,16 @@ cleanup()
 	fi
 
 	set +e
+
+	ip netns exec ${NS1} ./test_xdp_meta detach -d veth1 -f ${FS} -m skb 2> /dev/null
+	ip netns exec ${NS2} ./test_xdp_meta detach -d veth2 -f ${FS} -m skb 2> /dev/null
+
 	ip link del veth1 2> /dev/null
 	ip netns del ${NS1} 2> /dev/null
 	ip netns del ${NS2} 2> /dev/null
+
+	umount ${FS}
+	rm -fr ${FS}
 }
 
 ip link set dev lo xdp off 2>/dev/null > /dev/null
@@ -54,4 +66,43 @@ ip netns exec ${NS2} ip link set dev veth2 up
 ip netns exec ${NS1} ping -c 1 10.1.1.22
 ip netns exec ${NS2} ping -c 1 10.1.1.11
 
+#
+# Generic metadata part
+#
+
+# Cleanup
+ip netns exec ${NS1} ip link set dev veth1 xdp off
+ip netns exec ${NS2} ip link set dev veth2 xdp off
+
+ip netns exec ${NS1} tc filter del dev veth1 ingress
+ip netns exec ${NS2} tc filter del dev veth2 ingress
+
+# Enable metadata generation for every frame
+ip netns exec ${NS1} ./test_xdp_meta attach -d veth1 -f ${FS} -m skb -M
+ip netns exec ${NS2} ./test_xdp_meta attach -d veth2 -f ${FS} -m skb -M
+
+# Those two must fail: XDP prog drops packets < 128 bytes with metadata
+set +e
+
+ip netns exec ${NS1} ping -c 1 10.1.1.22 -W 0.2
+if [ "$?" = "0" ]; then
+	exit 1
+fi
+ip netns exec ${NS2} ping -c 1 10.1.1.11 -W 0.2
+if [ "$?" = "0" ]; then
+	exit 1
+fi
+
+set -e
+
+# Enable metadata only for frames >= 128 bytes
+ip netns exec ${NS1} ./test_xdp_meta update -d veth1 -f ${FS} -m skb -M 128
+ip netns exec ${NS2} ./test_xdp_meta update -d veth2 -f ${FS} -m skb -M 128
+
+# Must succeed
+ip netns exec ${NS1} ping -c 1 10.1.1.22
+ip netns exec ${NS2} ping -c 1 10.1.1.11
+ip netns exec ${NS1} ping -c 1 10.1.1.22 -s 128
+ip netns exec ${NS2} ping -c 1 10.1.1.11 -s 128
+
 exit 0
-- 
2.36.1


  parent reply	other threads:[~2022-06-28 19:50 UTC|newest]

Thread overview: 98+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2022-06-28 19:47 [xdp-hints] [PATCH RFC bpf-next 00/52] bpf, xdp: introduce and use Generic Hints/metadata Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 01/52] libbpf: factor out BTF loading from load_module_btfs() Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 02/52] libbpf: try to load vmlinux BTF from the kernel first Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 03/52] libbpf: add function to get the pair BTF ID + type ID for a given type Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 04/52] libbpf: patch module BTF ID into BPF insns Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 05/52] net, xdp: decouple XDP code from the core networking code Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 06/52] bpf: pass a pointer to union bpf_attr to bpf_link_ops::update_prog() Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 07/52] net, xdp: remove redundant arguments from dev_xdp_{at,de}tach_link() Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 08/52] net, xdp: factor out XDP install arguments to a separate structure Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 09/52] net, xdp: add ability to specify BTF ID for XDP metadata Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 10/52] net, xdp: add ability to specify frame size threshold " Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 11/52] libbpf: factor out __bpf_set_link_xdp_fd_replace() args into a struct Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 12/52] libbpf: add ability to set the BTF/type ID on setting XDP prog Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 13/52] libbpf: add ability to set the meta threshold " Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 14/52] libbpf: pass &bpf_link_create_opts directly to bpf_program__attach_fd() Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 15/52] libbpf: add bpf_program__attach_xdp_opts() Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 16/52] selftests/bpf: expand xdp_link to check that setting meta opts works Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 17/52] samples/bpf: pass a struct to sample_install_xdp() Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 18/52] samples/bpf: add ability to specify metadata threshold Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 19/52] stddef: make __struct_group() UAPI C++-friendly Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 20/52] net, xdp: move XDP metadata helpers into new xdp_meta.h Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 21/52] net, xdp: allow metadata > 32 Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 22/52] net, skbuff: add ability to skip skb metadata comparison Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 23/52] net, skbuff: constify the @skb argument of skb_hwtstamps() Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 24/52] bpf, xdp: declare generic XDP metadata structure Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 25/52] net, xdp: add basic generic metadata accessors Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 26/52] bpf, btf: add a pair of function to work with the BTF ID + type ID pair Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 27/52] net, xdp: add &sk_buff <-> &xdp_meta_generic converters Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 28/52] net, xdp: prefetch data a bit when building an skb from an &xdp_frame Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 29/52] net, xdp: try to fill skb fields when converting " Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 30/52] net, gro: decouple GRO from the NAPI layer Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 31/52] net, gro: expose some GRO API to use outside of NAPI Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 32/52] bpf, cpumap: switch to GRO from netif_receive_skb_list() Alexander Lobakin
2024-08-07 20:38   ` [xdp-hints] " Daniel Xu
2024-08-08  4:54     ` Lorenzo Bianconi
2024-08-08 11:57       ` Alexander Lobakin
2024-08-08 17:22         ` Lorenzo Bianconi
2024-08-08 20:52         ` Daniel Xu
2024-08-09 10:02           ` Jesper Dangaard Brouer
2024-08-09 12:20           ` Alexander Lobakin
2024-08-09 12:45             ` Toke Høiland-Jørgensen
2024-08-09 12:56               ` Alexander Lobakin
2024-08-09 13:42                 ` Toke Høiland-Jørgensen
2024-08-10  0:54                   ` Martin KaFai Lau
2024-08-10  8:02                   ` Lorenzo Bianconi
2024-08-13  1:33             ` Jakub Kicinski
2024-08-13  9:51               ` Jesper Dangaard Brouer
2024-08-10  8:00         ` Lorenzo Bianconi
2024-08-13 14:09         ` Alexander Lobakin
2024-08-13 14:54           ` Toke Høiland-Jørgensen
2024-08-13 15:57             ` Jesper Dangaard Brouer
2024-08-19 14:50               ` Alexander Lobakin
2024-08-21  0:29                 ` Daniel Xu
2024-08-21 13:16                   ` Alexander Lobakin
2024-08-21 16:36                     ` Daniel Xu
2024-08-13 16:14           ` Lorenzo Bianconi
2024-08-13 16:27           ` Lorenzo Bianconi
2024-08-13 16:31             ` Alexander Lobakin
2024-08-08 20:44       ` Daniel Xu
2024-08-09  9:32         ` Jesper Dangaard Brouer
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 33/52] bpf, cpumap: add option to set a timeout for deferred flush Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 34/52] samples/bpf: add 'timeout' option to xdp_redirect_cpu Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 35/52] net, skbuff: introduce napi_skb_cache_get_bulk() Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 36/52] bpf, cpumap: switch to napi_skb_cache_get_bulk() Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 37/52] rcupdate: fix access helpers for incomplete struct pointers on GCC < 10 Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 38/52] net, xdp: remove unused xdp_attachment_info::flags Alexander Lobakin
2022-06-28 19:47 ` [xdp-hints] [PATCH RFC bpf-next 39/52] net, xdp: make &xdp_attachment_info a bit more useful in drivers Alexander Lobakin
2022-06-28 19:48 ` [xdp-hints] [PATCH RFC bpf-next 40/52] net, xdp: add an RCU version of xdp_attachment_setup() Alexander Lobakin
2022-06-28 19:48 ` [xdp-hints] [PATCH RFC bpf-next 41/52] net, xdp: replace net_device::xdp_prog pointer with &xdp_attachment_info Alexander Lobakin
2022-06-28 19:48 ` [xdp-hints] [PATCH RFC bpf-next 42/52] net, xdp: shortcut skb->dev in bpf_prog_run_generic_xdp() Alexander Lobakin
2022-06-28 19:48 ` [xdp-hints] [PATCH RFC bpf-next 43/52] net, xdp: build XDP generic metadata on Generic (skb) XDP path Alexander Lobakin
2022-06-28 19:48 ` [xdp-hints] [PATCH RFC bpf-next 44/52] net, ice: allow XDP prog hot-swapping Alexander Lobakin
2022-06-28 19:48 ` [xdp-hints] [PATCH RFC bpf-next 45/52] net, ice: consolidate all skb fields processing Alexander Lobakin
2022-06-28 19:48 ` [xdp-hints] [PATCH RFC bpf-next 46/52] net, ice: use an onstack &xdp_meta_generic_rx to store HW frame info Alexander Lobakin
2022-06-28 19:48 ` [xdp-hints] [PATCH RFC bpf-next 47/52] net, ice: build XDP generic metadata Alexander Lobakin
2022-06-28 19:48 ` [xdp-hints] [PATCH RFC bpf-next 48/52] libbpf: compress Endianness ops with a macro Alexander Lobakin
2022-06-28 19:48 ` [xdp-hints] [PATCH RFC bpf-next 49/52] libbpf: add LE <--> CPU conversion helpers Alexander Lobakin
2022-06-28 19:48 ` [xdp-hints] [PATCH RFC bpf-next 50/52] libbpf: introduce a couple memory access helpers Alexander Lobakin
2022-06-28 19:48 ` [xdp-hints] [PATCH RFC bpf-next 51/52] selftests/bpf: fix using test_xdp_meta BPF prog via skeleton infra Alexander Lobakin
2022-06-28 19:48 ` Alexander Lobakin [this message]
2022-06-29  6:15 ` [xdp-hints] Re: [PATCH RFC bpf-next 00/52] bpf, xdp: introduce and use Generic Hints/metadata John Fastabend
2022-06-29 13:43   ` Toke Høiland-Jørgensen
2022-07-04 15:44     ` Alexander Lobakin
2022-07-04 17:13       ` Jesper Dangaard Brouer
2022-07-05 14:38         ` Alexander Lobakin
2022-07-05 19:08           ` Daniel Borkmann
2022-07-04 17:14       ` Toke Høiland-Jørgensen
2022-07-05 15:41         ` Alexander Lobakin
2022-07-05 18:51           ` Toke Høiland-Jørgensen
2022-07-06 13:50             ` Alexander Lobakin
2022-07-06 23:22               ` Toke Høiland-Jørgensen
2022-07-07 11:41                 ` Jesper Dangaard Brouer
2022-07-12 10:33                 ` Magnus Karlsson
2022-07-12 14:14                   ` Jesper Dangaard Brouer
2022-07-15 11:11                     ` Magnus Karlsson
2022-06-29 17:56   ` Zvi Effron
2022-06-30  7:39     ` Magnus Karlsson
2022-07-04 15:31   ` Alexander Lobakin

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: https://lists.xdp-project.net/postorius/lists/xdp-hints.xdp-project.net/

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20220628194812.1453059-53-alexandr.lobakin@intel.com \
    --to=alexandr.lobakin@intel.com \
    --cc=andrii@kernel.org \
    --cc=ast@kernel.org \
    --cc=bjorn@kernel.org \
    --cc=bpf@vger.kernel.org \
    --cc=daniel@iogearbox.net \
    --cc=davem@davemloft.net \
    --cc=edumazet@google.com \
    --cc=hawk@kernel.org \
    --cc=jesse.brandeburg@intel.com \
    --cc=john.fastabend@gmail.com \
    --cc=jonathan.lemon@gmail.com \
    --cc=kuba@kernel.org \
    --cc=larysa.zaremba@intel.com \
    --cc=linux-kernel@vger.kernel.org \
    --cc=lorenzo@kernel.org \
    --cc=maciej.fijalkowski@intel.com \
    --cc=magnus.karlsson@intel.com \
    --cc=michal.swiatkowski@linux.intel.com \
    --cc=netdev@vger.kernel.org \
    --cc=pabeni@redhat.com \
    --cc=toke@redhat.com \
    --cc=willemb@google.com \
    --cc=xdp-hints@xdp-project.net \
    --cc=yajun.deng@linux.dev \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox